image: docker:latest
services:
- docker:dind

variables:
  REPOSITORY_URL: 699987334313.dkr.ecr.eu-west-1.amazonaws.com/knowledge-matrix

before_script:
  - apk add --no-cache curl jq python py-pip nodejs
  - pip install awscli

stages:
  - build
  - deploy

build_backend:
  stage: build
  script:
    - $(aws ecr get-login --no-include-email --region eu-west-1)
    - echo "DB_HOST=$RDS_ENDPOINT" | tee -a backend/.env.production
    - echo "DB_USER=$RDS_USER" | tee -a backend/.env.production
    - echo "DB_PASSWORD=$RDS_PASSWORD" | tee -a backend/.env.production
    - echo "APP_KEY=$APP_KEY" | tee -a backend/.env.production
    - cp backend/.env.production backend/.env
    - docker build -f Dockerfile-backend -t $REPOSITORY_URL .
    - docker push $REPOSITORY_URL

build_frontend:
  stage: build
  script:
    - cd frontend/
    - npm install
    - npm run build
    - rm -rf public
    - mv build public
    - aws s3 sync public/ s3://knowledge-matrix --delete